--http://bugs.farmanager.com/view.php?id=2658
--http://bugs.farmanager.com/view.php?id=2659
if Far.Cfg_Get("Editor","DelRemovesBlocks")~="true" then return end

--Editor.Set constants: http://api.farmanager.com/ru/macro/macrocmd/prop_func/editor.html#editor.set
local PersistentBlocks = 2 -- 
local DelRemovesBlocks = 3 -- Delete  .    , Delete    ,     .
local BSLikeDel = 8 --  BackSpace (hlf:@Editor.BSLikeDel).
local getValue = -1 -- Value    -1,       ,     .

local function persistent()
  return Editor.Set(PersistentBlocks,getValue)==1
end

Macro {
  description="Persistent blocks: Del removes only if CurPos is inside block";
  area="Editor"; key="Del"; flags="EVSelection";
  uid="611F6431-4EF9-4BEB-9DF8-10C6F04D9C14";
  condition=function()
    if persistent() then
      local info = editor.GetInfo()
      local line = editor.GetString()
      return not (info.CurPos>=line.SelStart and (line.SelEnd==-1 or info.CurPos<=line.SelEnd))
    end
  end;
  action=function()
    local prev = Editor.Set(DelRemovesBlocks,0)
    Keys"AKey"
    Editor.Set(DelRemovesBlocks,prev)
  end;
}

--todo remove dependancy from DelRemovesBlocks
--todo consider eval akey macro
if Far.Cfg_Get("Editor","BSLikeDel")=="true" then Macro {
  description="Persistent blocks: BS removes only if CurPos is at right border of block";
  area="Editor"; key="BS"; flags="EVSelection";
  uid="D8ADB2DB-141F-4922-A393-4BECC83D482B";
  condition=function()
    if persistent() then
      local info = editor.GetInfo()
      local line = editor.GetString()
      return line.SelEnd+1~=info.CurPos or line.SelEnd==0
    end
  end;
  action=function()
    local prev = Editor.Set(BSLikeDel,0)
    Keys"AKey"
    Editor.Set(BSLikeDel,prev)
  end;
}end
